/*
	autoip.c
	2005/5/17
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <syslog.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <pcap.h>
#include <netinet/in.h>
#include <string.h>
#include <endian.h>
#include <sys/select.h>

#include "autoip.h"
#include "dhcpcd.h"
#include "client.h"

#if 0
 #define FUNCTION printf(">%s %d\n",__FUNCTION__,__LINE__)
#else
 #define FUNCTION
#endif

#ifdef AUTOIP_CONFIG
#define DEB_PRINT printf
extern	char		*IfName, *IfNameExt;
extern	unsigned char	ClientHwAddr[6];
extern	char		*ConfigDir;
extern	int		dhcp_ip_bound;

int arpCheck2(unsigned long);
//#define IFCONFIG_PATH "/bin/ifconfig"
#define IFCONFIG_PATH "/sbin/ifconfig"
#define AUTOIP_TAG "autoip"
#define AUTOIP_CACHE_FILE		"%s/"AUTOIP_TAG"-%s.cache"
#define AUTOIP_INFO_FILE		"%s/"AUTOIP_TAG"-%s.info"
//#define FINISH_TIME 10
#define FINISH_TIME 300
#define TIME_CHANGE_DETECT -30
static char *filter_cmd = "arp";
static unsigned long base = 0xa9fe0100; //169.254.1.0 

union ip_address
{
	unsigned long l_ip;
	struct
	{
		unsigned char c_ip[4];
	}c;
};

union ip_address ip;

struct arp_packet {
    u_char  eth_dst_ha[6];
    u_char  eth_src_ha[6];
    u_short eth_type;          /* 0x0806 (ARP)  */
    u_short arp_ha_type;       /* 1 (ether net) */
    u_short arp_pt_type;       /* 0x0800 (IP)   */
    u_char  arp_hlen;          /* 6 (ether net) */
    u_char  arp_plen;          /* 4 (IPv4)      */
    u_short arp_op;            /* 1 .. request, 2 .. reply, 3,4 .. rarp */
    u_char  arp_sender_ha[6];
    u_char  arp_sender_ip[4];
    u_char  arp_target_ha[6];
    u_char  arp_target_ip[4];
};
char errbuf[PCAP_ERRBUF_SIZE];;

//169.254.1.0/16169.254.254.255/16ޤǤΥIP
//169.254.254.255/16Ͻиʤ
unsigned long getRandomIP()
{
	unsigned long ret, seed;
	double rnd, rnd_base = RAND_MAX;
	seed=time(NULL)+ClientHwAddr[5]+4*ClientHwAddr[4]+8*ClientHwAddr[3]+
	16*ClientHwAddr[2]+32*ClientHwAddr[1]+64*ClientHwAddr[0];
	srandom(seed);
	rnd = random();
	rnd =(double)(rnd / rnd_base);
	ret = (unsigned long)(rnd * 0xfc * 0xff);
	if(ret > 0xfc * 0xff) ret = 0xfc * 0xff; //ǰΤ
	return base + ret;
}

int checkAutoIPFile()
{
	FILE *fp = NULL;
	char infofile[64];
	snprintf(infofile,sizeof(infofile),AUTOIP_INFO_FILE,ConfigDir,IfNameExt);
#ifdef AUTOIP_DEBUG
	DEB_PRINT("file name %s\n",infofile);
#endif
	fp=fopen(infofile,"r");
	if ( fp == NULL )
	{
		return 1;
	}
	fclose (fp);
	return 0;
}

void writeAutoIPFile()
{
	FILE *fp;
	char infofile[64];
	snprintf(infofile,sizeof(infofile),AUTOIP_INFO_FILE,ConfigDir,IfNameExt);
	fp=fopen(infofile,"w");
	if ( fp == NULL )
	{
		syslog(LOG_ERR,"writeAutoIPinfoFile: fopen: %m\n");
		exit(1);
	}
#if __BYTE_ORDER == __BIG_ENDIAN
	fprintf(fp,"%u.%u.%u.%u\n",ip.c.c_ip[0],ip.c.c_ip[1],ip.c.c_ip[2],ip.c.c_ip[3]);
#else
	fprintf(fp,"%u.%u.%u.%u\n",ip.c.c_ip[3],ip.c.c_ip[2],ip.c.c_ip[1],ip.c.c_ip[0]);
#endif
	fclose (fp);
}

void wirteAutoIPCache()
{
	int i;
	char cachefile[64];
	snprintf(cachefile,sizeof(cachefile),AUTOIP_CACHE_FILE,ConfigDir,IfNameExt);
	i=open(cachefile,O_WRONLY|O_CREAT|O_TRUNC,S_IRUSR+S_IWUSR);
	if(i){
		write(i,(char *)&ip,sizeof(ip));
		close(i);
	}
}

extern int rService;

int readAutoIPCache()
{
	int i,o;
	char cachefile[64];
	snprintf(cachefile,sizeof(cachefile),AUTOIP_CACHE_FILE,ConfigDir,IfNameExt);
	i=open(cachefile,O_RDONLY);
	if ( i == -1 ) return -1;
	o=read(i,(char *)&ip,sizeof(ip));
	close(i);
	if ( o != sizeof(ip) ) return -1;
	if ( ip.l_ip == 0 ) return -1;
	if ( ip.l_ip < 0xa9fe0100 ) return -1;
	if ( ip.l_ip > 0xa9fefeff ) return -1;
	return 0;
}

int setAutoIP()
{
	char cmd[256];
	int ret, count = 0;
	unsigned long pre_ip = 0;
#ifdef AUTOIP_DEBUG
	DEB_PRINT("setAutoIP %s called\n",IfName);
	DEB_PRINT("MAC address = %02x:%02x:%02x:%02x:%02x:%02x\n",
	ClientHwAddr[0], ClientHwAddr[1], ClientHwAddr[2],
	ClientHwAddr[3], ClientHwAddr[4], ClientHwAddr[5]);
#endif
	if(checkAutoIPFile()) return 0;
	if(readAutoIPCache())
		ip.l_ip = getRandomIP();
	else 
		pre_ip = ip.l_ip;
	if(dhcp_ip_bound){
		pre_ip = 0;
		dhcp_ip_bound = 0;
	}
IPCONFIG:
	sprintf(cmd,"%s %s %u.%u.%u.%u netmask 255.255.0.0 up",
#if __BYTE_ORDER == __BIG_ENDIAN
	IFCONFIG_PATH, IfName,ip.c.c_ip[0],ip.c.c_ip[1],ip.c.c_ip[2],ip.c.c_ip[3]);
#else
	IFCONFIG_PATH, IfName,ip.c.c_ip[3],ip.c.c_ip[2],ip.c.c_ip[1],ip.c.c_ip[0]);
#endif
	system(cmd);
#ifdef AUTOIP_DEBUG
	DEB_PRINT("%s\n",cmd);
#endif

#if __BYTE_ORDER == __BIG_ENDIAN
	ret = arpCheck2(ip.l_ip);
#else
	ret = arpCheck2(htonl(ip.l_ip));
#endif
#ifdef AUTOIP_DEBUG
	DEB_PRINT("Arp result %d\n",ret);
#endif
	if(ret 	!= 0){
		ip.l_ip = getRandomIP();
		count++;
		if(count < 65024) goto IPCONFIG;
	}
	if(pre_ip != ip.l_ip){
		wirteAutoIPCache();
		writeAutoIPFile();
		DEB_PRINT("/etc/init.d/rService\n");
		//system("/etc/init.d/rService");
		if (rService)
			system("/etc/init.d/rService");
		else
			rService = 1;
	}
	else if (!rService)
		rService = 1;
	
	return 1;
}

char *
mac2str( char *buff, int len, u_char mac[] )
{
    snprintf( buff, len, "%2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x",
	      mac[0], mac[1], mac[2], mac[3], mac[4], mac[5] );
    return buff;
}

char *
ip2str( char *buff, int len, u_char ip[] )
{
    snprintf( buff, len, "%d.%d.%d.%d",
	      ip[0], ip[1], ip[2], ip[3] );
    return buff;
}

char *
ipu2str( char *buff, int len, u_long ip )
{
    return ip2str( buff, len, (u_char *)&ip );
}


char *
tv2str( char *buff, int len, struct timeval *tv )
{
    struct tm *gtm;

    gtm = gmtime( &(tv->tv_sec) );

    snprintf( buff, len, "%d/%2.2d/%2.2d %2.2d:%2.2d:%2.2d.%6.6d",
	      gtm->tm_year+1900,
	      gtm->tm_mon+1,
	      gtm->tm_mday,
	      gtm->tm_hour,
	      gtm->tm_min,
	      gtm->tm_sec,
	      (int)(tv->tv_usec) );

    return buff;
}


int
hex_dump( unsigned char data[], int len )
{
    int p;

    for( p=0; p < len; p++ ){
	if( (p%16) == 0 ){
	    printf( "%4.4x: ", p );
	}else if( (p%8) == 0 ){
	    printf( " " );
	}
	printf( "%2.2x ", data[p] );
	if( (p%16) == 15 ){
	    printf( "\n" );
	}
    }
    printf( "\n" );

    return 0;
}

pcap_t * cap_open( char *dev )
{
    pcap_t *pd;
    int snaplen=128;
    int ret;
    struct bpf_program fcode;
    unsigned int localnet, netmask;
    int datalink;
    char buf1[64], buf2[64];

    pd = pcap_open_live( dev, snaplen, 0, 100, errbuf );
    if( pd == NULL){
	fprintf( stderr, "pcap_open_live: %s", errbuf );
	exit(1);
    }
    ret = pcap_lookupnet( dev, &localnet, &netmask, errbuf );
    if( ret < 0 ){
	fprintf( stderr, "pcap_lookupnet: %s", errbuf );
	exit(1);
    }
    fprintf( stderr, "dev: %s, localnet: %s/%s\n",
	     dev,
	     ipu2str( buf1, 64, localnet),
	     ipu2str( buf2, 64, netmask)  );

    ret = pcap_compile( pd, &fcode, filter_cmd, 0, netmask );
    if( ret < 0 ){
	fprintf( stderr, "pcap_compile: \n" );
	exit(1);
    }

    ret = pcap_setfilter( pd, &fcode );
    if( ret < 0 ){
	fprintf( stderr, "pcap_setfilter: \n" );
	exit(1);
    }

    datalink = pcap_datalink(pd);

    return pd;
}

int print_arp_info( struct arp_packet *pkt, struct timeval *tv )
{
    char bf0[64], bf1[64], bf2[64];

    printf( "%s [%s] -> [%s] %s\n",
	    tv2str( bf0, 64, tv ), 
	    mac2str( bf1, 128, pkt->eth_src_ha ),
	    mac2str( bf2, 128, pkt->eth_dst_ha ),
	    (ntohs(pkt->arp_op) == 1)?"request":"reply" );
    printf( "\tsender: %s %s\n",
	    mac2str( bf1, 64, pkt->arp_sender_ha ),
	    ip2str( bf2, 64, pkt->arp_sender_ip ) );
    printf( "\ttarget: %s %s\n",
	    mac2str( bf1, 64, pkt->arp_target_ha ),
	    ip2str( bf2, 64, pkt->arp_target_ip ) );

    fflush(stdout);
    return 0;
}

//void conflictIP()
int conflictIP()
{
	time_t start_time;
	time_t now_time;
	int delta_time;
	pcap_t *pd;
	struct timeval tv;
	char *dev = "eth0";
	struct pcap_pkthdr hdr;
	const u_char *ptr;
	struct arp_packet arp_data;
	struct arp_packet * pkt = &arp_data;
#if __BYTE_ORDER == __BIG_ENDIAN
#else
	union ip_address arp_ip;
#endif

	if(checkAutoIPFile()){
		// not autoIP mode. skip conflictIP().
		return 0;
	}
	
	pd = cap_open( dev );
	if ( !pd ){
		syslog(LOG_ERR,"%s:pcap open fail",__FUNCTION__);
		return 0;
	}
	start_time = time(NULL);

	while(1){
		fd_set read_fd_set;
		int pcap_fd;
		int nready;
		struct timeval timeout;
FUNCTION;
		pcap_fd = pcap_fileno(pd);
		FD_ZERO(&read_fd_set);
		FD_SET(pcap_fd,&read_fd_set);
		timeout.tv_sec    = 3;
		timeout.tv_usec   = 0;
		nready = select(pcap_fd + 1,&read_fd_set, NULL, NULL, &timeout);
		if (FD_ISSET(pcap_fd, &read_fd_set)){
			ptr = pcap_next( pd, &hdr);
FUNCTION;
			now_time = time(NULL);
			delta_time = (int)(now_time - start_time);
			//if(delta_time >= FINISH_TIME) return;
			//if(delta_time <= TIME_CHANGE_DETECT) return;
			//if(delta_time >= FINISH_TIME) return 0;
			//if(delta_time <= TIME_CHANGE_DETECT) return 0;
			if(delta_time >= FINISH_TIME) break;
			if(delta_time <= TIME_CHANGE_DETECT) break;
			if(ptr == NULL) continue;
			if( hdr.caplen < sizeof( struct arp_packet) ){
				continue;
			}
			memcpy( pkt, ptr, sizeof(struct arp_packet) );
			memcpy( &tv, &(hdr.ts), sizeof( struct timeval) );
			if( ntohs( pkt->eth_type ) != 0x806 ) continue;
			if( ntohs( pkt->arp_ha_type ) != 1  )
				if( ntohs( pkt->arp_pt_type ) != 0x800 )
					if( pkt->arp_hlen != 6 ) continue;
			if( pkt->arp_plen != 4 ) continue;
			if( (ntohs(pkt->arp_op) == 1) || (ntohs(pkt->arp_op) == 2) ){
				print_arp_info( &arp_data, &tv );
	#if __BYTE_ORDER == __BIG_ENDIAN
				if(!memcmp(arp_data.arp_sender_ip, ip.c.c_ip, 4))
	#else
				arp_ip.l_ip = ntohl(*(unsigned long *)&arp_data.arp_sender_ip);
				if(!memcmp(arp_ip.c.c_ip, ip.c.c_ip, 4))
	#endif
					if(memcmp(arp_data.arp_sender_ha, ClientHwAddr, 6))
					{
						syslog(LOG_ERR,"conflict AutoIP\n");
						pcap_close( pd );
						return 1;
					}
			}
		}else{
			printf("select timeout\n");
			break;
		}
	}
	
FUNCTION;
	pcap_close( pd );
	return 0;

}

#endif //AUTOIP_CONFIG


